/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.stimmeingabe.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfiguration;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractStimmeingabePlausiKonfigurationSearch {

  @Inject
  protected transient StimmeingabePlausiKonfigurationExtendedDAO dao;

  public AbstractStimmeingabePlausiKonfigurationSearch() {
    super();
  }

  public List<StimmeingabePlausiKonfiguration> getSearchResult(StimmeingabePlausiKonfigurationSearchParameters searchParameters, EagerLoadingCollector<StimmeingabePlausiKonfiguration> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<StimmeingabePlausiKonfiguration> querySearchResult(StimmeingabePlausiKonfigurationSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
